import { Injectable } from '@angular/core';
import {
  ActivatedRouteSnapshot,
  Resolve,
  Router,
  RouterStateSnapshot,
} from '@angular/router';
import { catchError, Observable, throwError } from 'rxjs';

import { DomainService } from '../services/domain.service';

@Injectable({
  providedIn: 'root',
})
export class DomainResolver implements Resolve<any> {
  /**
   * Constructor
   */
  constructor(private _domainService: DomainService) {}

  // -----------------------------------------------------------------------------------------------------
  // @ Public methods
  // -----------------------------------------------------------------------------------------------------

  /**
   * Resolver
   *
   * @param route
   * @param state
   */
  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot
  ): Observable<{
    domainSetting: any;
  }> {
    return this._domainService.getDomainSetting();
  }
}
